# coding: utf-8

"""
    Kubernetes

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: unversioned
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictInt, conlist
from benny_kubernetes.models.io_k8s_api_apps_v1_replica_set_condition import IoK8sApiAppsV1ReplicaSetCondition

class IoK8sApiAppsV1ReplicaSetStatus(BaseModel):
    """
    ReplicaSetStatus represents the current status of a ReplicaSet.  # noqa: E501
    """
    available_replicas: Optional[StrictInt] = Field(None, alias="availableReplicas", description="The number of available replicas (ready for at least minReadySeconds) for this replica set.")
    conditions: Optional[conlist(IoK8sApiAppsV1ReplicaSetCondition)] = Field(None, description="Represents the latest available observations of a replica set's current state.")
    fully_labeled_replicas: Optional[StrictInt] = Field(None, alias="fullyLabeledReplicas", description="The number of pods that have labels matching the labels of the pod template of the replicaset.")
    observed_generation: Optional[StrictInt] = Field(None, alias="observedGeneration", description="ObservedGeneration reflects the generation of the most recently observed ReplicaSet.")
    ready_replicas: Optional[StrictInt] = Field(None, alias="readyReplicas", description="The number of ready replicas for this replica set.")
    replicas: StrictInt = Field(..., description="Replicas is the most recently oberved number of replicas. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller/#what-is-a-replicationcontroller")
    __properties = ["availableReplicas", "conditions", "fullyLabeledReplicas", "observedGeneration", "readyReplicas", "replicas"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> IoK8sApiAppsV1ReplicaSetStatus:
        """Create an instance of IoK8sApiAppsV1ReplicaSetStatus from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in conditions (list)
        _items = []
        if self.conditions:
            for _item in self.conditions:
                if _item:
                    _items.append(_item.to_dict())
            _dict['conditions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> IoK8sApiAppsV1ReplicaSetStatus:
        """Create an instance of IoK8sApiAppsV1ReplicaSetStatus from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return IoK8sApiAppsV1ReplicaSetStatus.parse_obj(obj)

        _obj = IoK8sApiAppsV1ReplicaSetStatus.parse_obj({
            "available_replicas": obj.get("availableReplicas"),
            "conditions": [IoK8sApiAppsV1ReplicaSetCondition.from_dict(_item) for _item in obj.get("conditions")] if obj.get("conditions") is not None else None,
            "fully_labeled_replicas": obj.get("fullyLabeledReplicas"),
            "observed_generation": obj.get("observedGeneration"),
            "ready_replicas": obj.get("readyReplicas"),
            "replicas": obj.get("replicas")
        })
        return _obj


