# coding: utf-8

"""
    Kubernetes

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: unversioned
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from benny_kubernetes.models.io_k8s_api_autoscaling_v2beta2_external_metric_source import IoK8sApiAutoscalingV2beta2ExternalMetricSource
from benny_kubernetes.models.io_k8s_api_autoscaling_v2beta2_object_metric_source import IoK8sApiAutoscalingV2beta2ObjectMetricSource
from benny_kubernetes.models.io_k8s_api_autoscaling_v2beta2_pods_metric_source import IoK8sApiAutoscalingV2beta2PodsMetricSource
from benny_kubernetes.models.io_k8s_api_autoscaling_v2beta2_resource_metric_source import IoK8sApiAutoscalingV2beta2ResourceMetricSource

class IoK8sApiAutoscalingV2beta2MetricSpec(BaseModel):
    """
    MetricSpec specifies how to scale based on a single metric (only `type` and one other matching field should be set at once).  # noqa: E501
    """
    external: Optional[IoK8sApiAutoscalingV2beta2ExternalMetricSource] = None
    object: Optional[IoK8sApiAutoscalingV2beta2ObjectMetricSource] = None
    pods: Optional[IoK8sApiAutoscalingV2beta2PodsMetricSource] = None
    resource: Optional[IoK8sApiAutoscalingV2beta2ResourceMetricSource] = None
    type: StrictStr = Field(..., description="type is the type of metric source.  It should be one of \"Object\", \"Pods\" or \"Resource\", each mapping to a matching field in the object.")
    __properties = ["external", "object", "pods", "resource", "type"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> IoK8sApiAutoscalingV2beta2MetricSpec:
        """Create an instance of IoK8sApiAutoscalingV2beta2MetricSpec from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of external
        if self.external:
            _dict['external'] = self.external.to_dict()
        # override the default output from pydantic by calling `to_dict()` of object
        if self.object:
            _dict['object'] = self.object.to_dict()
        # override the default output from pydantic by calling `to_dict()` of pods
        if self.pods:
            _dict['pods'] = self.pods.to_dict()
        # override the default output from pydantic by calling `to_dict()` of resource
        if self.resource:
            _dict['resource'] = self.resource.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> IoK8sApiAutoscalingV2beta2MetricSpec:
        """Create an instance of IoK8sApiAutoscalingV2beta2MetricSpec from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return IoK8sApiAutoscalingV2beta2MetricSpec.parse_obj(obj)

        _obj = IoK8sApiAutoscalingV2beta2MetricSpec.parse_obj({
            "external": IoK8sApiAutoscalingV2beta2ExternalMetricSource.from_dict(obj.get("external")) if obj.get("external") is not None else None,
            "object": IoK8sApiAutoscalingV2beta2ObjectMetricSource.from_dict(obj.get("object")) if obj.get("object") is not None else None,
            "pods": IoK8sApiAutoscalingV2beta2PodsMetricSource.from_dict(obj.get("pods")) if obj.get("pods") is not None else None,
            "resource": IoK8sApiAutoscalingV2beta2ResourceMetricSource.from_dict(obj.get("resource")) if obj.get("resource") is not None else None,
            "type": obj.get("type")
        })
        return _obj


