# coding: utf-8

"""
    Kubernetes

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: unversioned
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr
from benny_kubernetes.models.io_k8s_api_batch_v2alpha1_job_template_spec import IoK8sApiBatchV2alpha1JobTemplateSpec

class IoK8sApiBatchV2alpha1CronJobSpec(BaseModel):
    """
    CronJobSpec describes how the job execution will look like and when it will actually run.  # noqa: E501
    """
    concurrency_policy: Optional[StrictStr] = Field(None, alias="concurrencyPolicy", description="Specifies how to treat concurrent executions of a Job. Valid values are: - \"Allow\" (default): allows CronJobs to run concurrently; - \"Forbid\": forbids concurrent runs, skipping next run if previous run hasn't finished yet; - \"Replace\": cancels currently running job and replaces it with a new one")
    failed_jobs_history_limit: Optional[StrictInt] = Field(None, alias="failedJobsHistoryLimit", description="The number of failed finished jobs to retain. This is a pointer to distinguish between explicit zero and not specified.")
    job_template: IoK8sApiBatchV2alpha1JobTemplateSpec = Field(..., alias="jobTemplate")
    schedule: StrictStr = Field(..., description="The schedule in Cron format, see https://en.wikipedia.org/wiki/Cron.")
    starting_deadline_seconds: Optional[StrictInt] = Field(None, alias="startingDeadlineSeconds", description="Optional deadline in seconds for starting the job if it misses scheduled time for any reason.  Missed jobs executions will be counted as failed ones.")
    successful_jobs_history_limit: Optional[StrictInt] = Field(None, alias="successfulJobsHistoryLimit", description="The number of successful finished jobs to retain. This is a pointer to distinguish between explicit zero and not specified.")
    suspend: Optional[StrictBool] = Field(None, description="This flag tells the controller to suspend subsequent executions, it does not apply to already started executions.  Defaults to false.")
    __properties = ["concurrencyPolicy", "failedJobsHistoryLimit", "jobTemplate", "schedule", "startingDeadlineSeconds", "successfulJobsHistoryLimit", "suspend"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> IoK8sApiBatchV2alpha1CronJobSpec:
        """Create an instance of IoK8sApiBatchV2alpha1CronJobSpec from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of job_template
        if self.job_template:
            _dict['jobTemplate'] = self.job_template.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> IoK8sApiBatchV2alpha1CronJobSpec:
        """Create an instance of IoK8sApiBatchV2alpha1CronJobSpec from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return IoK8sApiBatchV2alpha1CronJobSpec.parse_obj(obj)

        _obj = IoK8sApiBatchV2alpha1CronJobSpec.parse_obj({
            "concurrency_policy": obj.get("concurrencyPolicy"),
            "failed_jobs_history_limit": obj.get("failedJobsHistoryLimit"),
            "job_template": IoK8sApiBatchV2alpha1JobTemplateSpec.from_dict(obj.get("jobTemplate")) if obj.get("jobTemplate") is not None else None,
            "schedule": obj.get("schedule"),
            "starting_deadline_seconds": obj.get("startingDeadlineSeconds"),
            "successful_jobs_history_limit": obj.get("successfulJobsHistoryLimit"),
            "suspend": obj.get("suspend")
        })
        return _obj


