# coding: utf-8

"""
    Kubernetes

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: unversioned
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Dict, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr
from benny_kubernetes.models.io_k8s_api_core_v1_local_object_reference import IoK8sApiCoreV1LocalObjectReference

class IoK8sApiCoreV1CSIVolumeSource(BaseModel):
    """
    Represents a source location of a volume to mount, managed by an external CSI driver  # noqa: E501
    """
    driver: StrictStr = Field(..., description="Driver is the name of the CSI driver that handles this volume. Consult with your admin for the correct name as registered in the cluster.")
    fs_type: Optional[StrictStr] = Field(None, alias="fsType", description="Filesystem type to mount. Ex. \"ext4\", \"xfs\", \"ntfs\". If not provided, the empty value is passed to the associated CSI driver which will determine the default filesystem to apply.")
    node_publish_secret_ref: Optional[IoK8sApiCoreV1LocalObjectReference] = Field(None, alias="nodePublishSecretRef")
    read_only: Optional[StrictBool] = Field(None, alias="readOnly", description="Specifies a read-only configuration for the volume. Defaults to false (read/write).")
    volume_attributes: Optional[Dict[str, StrictStr]] = Field(None, alias="volumeAttributes", description="VolumeAttributes stores driver-specific properties that are passed to the CSI driver. Consult your driver's documentation for supported values.")
    __properties = ["driver", "fsType", "nodePublishSecretRef", "readOnly", "volumeAttributes"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> IoK8sApiCoreV1CSIVolumeSource:
        """Create an instance of IoK8sApiCoreV1CSIVolumeSource from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of node_publish_secret_ref
        if self.node_publish_secret_ref:
            _dict['nodePublishSecretRef'] = self.node_publish_secret_ref.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> IoK8sApiCoreV1CSIVolumeSource:
        """Create an instance of IoK8sApiCoreV1CSIVolumeSource from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return IoK8sApiCoreV1CSIVolumeSource.parse_obj(obj)

        _obj = IoK8sApiCoreV1CSIVolumeSource.parse_obj({
            "driver": obj.get("driver"),
            "fs_type": obj.get("fsType"),
            "node_publish_secret_ref": IoK8sApiCoreV1LocalObjectReference.from_dict(obj.get("nodePublishSecretRef")) if obj.get("nodePublishSecretRef") is not None else None,
            "read_only": obj.get("readOnly"),
            "volume_attributes": obj.get("volumeAttributes")
        })
        return _obj


