# coding: utf-8

"""
    Kubernetes

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: unversioned
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr
from benny_kubernetes.models.io_k8s_api_core_v1_event_series import IoK8sApiCoreV1EventSeries
from benny_kubernetes.models.io_k8s_api_core_v1_event_source import IoK8sApiCoreV1EventSource
from benny_kubernetes.models.io_k8s_api_core_v1_object_reference import IoK8sApiCoreV1ObjectReference
from benny_kubernetes.models.io_k8s_apimachinery_pkg_apis_meta_v1_object_meta import IoK8sApimachineryPkgApisMetaV1ObjectMeta

class IoK8sApiCoreV1Event(BaseModel):
    """
    Event is a report of an event somewhere in the cluster.  # noqa: E501
    """
    action: Optional[StrictStr] = Field(None, description="What action was taken/failed regarding to the Regarding object.")
    api_version: Optional[StrictStr] = Field(None, alias="apiVersion", description="APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources")
    count: Optional[StrictInt] = Field(None, description="The number of times this event has occurred.")
    event_time: Optional[datetime] = Field(None, alias="eventTime", description="MicroTime is version of Time with microsecond level precision.")
    first_timestamp: Optional[datetime] = Field(None, alias="firstTimestamp", description="Time is a wrapper around time.Time which supports correct marshaling to YAML and JSON.  Wrappers are provided for many of the factory methods that the time package offers.")
    involved_object: IoK8sApiCoreV1ObjectReference = Field(..., alias="involvedObject")
    kind: Optional[StrictStr] = Field(None, description="Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds")
    last_timestamp: Optional[datetime] = Field(None, alias="lastTimestamp", description="Time is a wrapper around time.Time which supports correct marshaling to YAML and JSON.  Wrappers are provided for many of the factory methods that the time package offers.")
    message: Optional[StrictStr] = Field(None, description="A human-readable description of the status of this operation.")
    metadata: IoK8sApimachineryPkgApisMetaV1ObjectMeta = Field(...)
    reason: Optional[StrictStr] = Field(None, description="This should be a short, machine understandable string that gives the reason for the transition into the object's current status.")
    related: Optional[IoK8sApiCoreV1ObjectReference] = None
    reporting_component: Optional[StrictStr] = Field(None, alias="reportingComponent", description="Name of the controller that emitted this Event, e.g. `kubernetes.io/kubelet`.")
    reporting_instance: Optional[StrictStr] = Field(None, alias="reportingInstance", description="ID of the controller instance, e.g. `kubelet-xyzf`.")
    series: Optional[IoK8sApiCoreV1EventSeries] = None
    source: Optional[IoK8sApiCoreV1EventSource] = None
    type: Optional[StrictStr] = Field(None, description="Type of this event (Normal, Warning), new types could be added in the future")
    __properties = ["action", "apiVersion", "count", "eventTime", "firstTimestamp", "involvedObject", "kind", "lastTimestamp", "message", "metadata", "reason", "related", "reportingComponent", "reportingInstance", "series", "source", "type"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> IoK8sApiCoreV1Event:
        """Create an instance of IoK8sApiCoreV1Event from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of involved_object
        if self.involved_object:
            _dict['involvedObject'] = self.involved_object.to_dict()
        # override the default output from pydantic by calling `to_dict()` of metadata
        if self.metadata:
            _dict['metadata'] = self.metadata.to_dict()
        # override the default output from pydantic by calling `to_dict()` of related
        if self.related:
            _dict['related'] = self.related.to_dict()
        # override the default output from pydantic by calling `to_dict()` of series
        if self.series:
            _dict['series'] = self.series.to_dict()
        # override the default output from pydantic by calling `to_dict()` of source
        if self.source:
            _dict['source'] = self.source.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> IoK8sApiCoreV1Event:
        """Create an instance of IoK8sApiCoreV1Event from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return IoK8sApiCoreV1Event.parse_obj(obj)

        _obj = IoK8sApiCoreV1Event.parse_obj({
            "action": obj.get("action"),
            "api_version": obj.get("apiVersion"),
            "count": obj.get("count"),
            "event_time": obj.get("eventTime"),
            "first_timestamp": obj.get("firstTimestamp"),
            "involved_object": IoK8sApiCoreV1ObjectReference.from_dict(obj.get("involvedObject")) if obj.get("involvedObject") is not None else None,
            "kind": obj.get("kind"),
            "last_timestamp": obj.get("lastTimestamp"),
            "message": obj.get("message"),
            "metadata": IoK8sApimachineryPkgApisMetaV1ObjectMeta.from_dict(obj.get("metadata")) if obj.get("metadata") is not None else None,
            "reason": obj.get("reason"),
            "related": IoK8sApiCoreV1ObjectReference.from_dict(obj.get("related")) if obj.get("related") is not None else None,
            "reporting_component": obj.get("reportingComponent"),
            "reporting_instance": obj.get("reportingInstance"),
            "series": IoK8sApiCoreV1EventSeries.from_dict(obj.get("series")) if obj.get("series") is not None else None,
            "source": IoK8sApiCoreV1EventSource.from_dict(obj.get("source")) if obj.get("source") is not None else None,
            "type": obj.get("type")
        })
        return _obj


