# coding: utf-8

"""
    Kubernetes

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: unversioned
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from benny_kubernetes.models.io_k8s_api_core_v1_resource_requirements import IoK8sApiCoreV1ResourceRequirements
from benny_kubernetes.models.io_k8s_api_core_v1_typed_local_object_reference import IoK8sApiCoreV1TypedLocalObjectReference
from benny_kubernetes.models.io_k8s_apimachinery_pkg_apis_meta_v1_label_selector import IoK8sApimachineryPkgApisMetaV1LabelSelector

class IoK8sApiCoreV1PersistentVolumeClaimSpec(BaseModel):
    """
    PersistentVolumeClaimSpec describes the common attributes of storage devices and allows a Source for provider-specific attributes  # noqa: E501
    """
    access_modes: Optional[conlist(StrictStr)] = Field(None, alias="accessModes", description="AccessModes contains the desired access modes the volume should have. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1")
    data_source: Optional[IoK8sApiCoreV1TypedLocalObjectReference] = Field(None, alias="dataSource")
    resources: Optional[IoK8sApiCoreV1ResourceRequirements] = None
    selector: Optional[IoK8sApimachineryPkgApisMetaV1LabelSelector] = None
    storage_class_name: Optional[StrictStr] = Field(None, alias="storageClassName", description="Name of the StorageClass required by the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#class-1")
    volume_mode: Optional[StrictStr] = Field(None, alias="volumeMode", description="volumeMode defines what type of volume is required by the claim. Value of Filesystem is implied when not included in claim spec.")
    volume_name: Optional[StrictStr] = Field(None, alias="volumeName", description="VolumeName is the binding reference to the PersistentVolume backing this claim.")
    __properties = ["accessModes", "dataSource", "resources", "selector", "storageClassName", "volumeMode", "volumeName"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> IoK8sApiCoreV1PersistentVolumeClaimSpec:
        """Create an instance of IoK8sApiCoreV1PersistentVolumeClaimSpec from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of data_source
        if self.data_source:
            _dict['dataSource'] = self.data_source.to_dict()
        # override the default output from pydantic by calling `to_dict()` of resources
        if self.resources:
            _dict['resources'] = self.resources.to_dict()
        # override the default output from pydantic by calling `to_dict()` of selector
        if self.selector:
            _dict['selector'] = self.selector.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> IoK8sApiCoreV1PersistentVolumeClaimSpec:
        """Create an instance of IoK8sApiCoreV1PersistentVolumeClaimSpec from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return IoK8sApiCoreV1PersistentVolumeClaimSpec.parse_obj(obj)

        _obj = IoK8sApiCoreV1PersistentVolumeClaimSpec.parse_obj({
            "access_modes": obj.get("accessModes"),
            "data_source": IoK8sApiCoreV1TypedLocalObjectReference.from_dict(obj.get("dataSource")) if obj.get("dataSource") is not None else None,
            "resources": IoK8sApiCoreV1ResourceRequirements.from_dict(obj.get("resources")) if obj.get("resources") is not None else None,
            "selector": IoK8sApimachineryPkgApisMetaV1LabelSelector.from_dict(obj.get("selector")) if obj.get("selector") is not None else None,
            "storage_class_name": obj.get("storageClassName"),
            "volume_mode": obj.get("volumeMode"),
            "volume_name": obj.get("volumeName")
        })
        return _obj


