# coding: utf-8

"""
    Kubernetes

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: unversioned
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class IoK8sApiCoreV1PodCondition(BaseModel):
    """
    PodCondition contains details for the current condition of this pod.  # noqa: E501
    """
    last_probe_time: Optional[datetime] = Field(None, alias="lastProbeTime", description="Time is a wrapper around time.Time which supports correct marshaling to YAML and JSON.  Wrappers are provided for many of the factory methods that the time package offers.")
    last_transition_time: Optional[datetime] = Field(None, alias="lastTransitionTime", description="Time is a wrapper around time.Time which supports correct marshaling to YAML and JSON.  Wrappers are provided for many of the factory methods that the time package offers.")
    message: Optional[StrictStr] = Field(None, description="Human-readable message indicating details about last transition.")
    reason: Optional[StrictStr] = Field(None, description="Unique, one-word, CamelCase reason for the condition's last transition.")
    status: StrictStr = Field(..., description="Status is the status of the condition. Can be True, False, Unknown. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-conditions")
    type: StrictStr = Field(..., description="Type is the type of the condition. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-conditions")
    __properties = ["lastProbeTime", "lastTransitionTime", "message", "reason", "status", "type"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> IoK8sApiCoreV1PodCondition:
        """Create an instance of IoK8sApiCoreV1PodCondition from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> IoK8sApiCoreV1PodCondition:
        """Create an instance of IoK8sApiCoreV1PodCondition from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return IoK8sApiCoreV1PodCondition.parse_obj(obj)

        _obj = IoK8sApiCoreV1PodCondition.parse_obj({
            "last_probe_time": obj.get("lastProbeTime"),
            "last_transition_time": obj.get("lastTransitionTime"),
            "message": obj.get("message"),
            "reason": obj.get("reason"),
            "status": obj.get("status"),
            "type": obj.get("type")
        })
        return _obj


