# coding: utf-8

"""
    Kubernetes

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: unversioned
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from benny_kubernetes.models.io_k8s_api_core_v1_container_status import IoK8sApiCoreV1ContainerStatus
from benny_kubernetes.models.io_k8s_api_core_v1_pod_condition import IoK8sApiCoreV1PodCondition
from benny_kubernetes.models.io_k8s_api_core_v1_pod_ip import IoK8sApiCoreV1PodIP

class IoK8sApiCoreV1PodStatus(BaseModel):
    """
    PodStatus represents information about the status of a pod. Status may trail the actual state of a system, especially if the node that hosts the pod cannot contact the control plane.  # noqa: E501
    """
    conditions: Optional[conlist(IoK8sApiCoreV1PodCondition)] = Field(None, description="Current service state of pod. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-conditions")
    container_statuses: Optional[conlist(IoK8sApiCoreV1ContainerStatus)] = Field(None, alias="containerStatuses", description="The list has one entry per container in the manifest. Each entry is currently the output of `docker inspect`. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-and-container-status")
    ephemeral_container_statuses: Optional[conlist(IoK8sApiCoreV1ContainerStatus)] = Field(None, alias="ephemeralContainerStatuses", description="Status for any ephemeral containers that have run in this pod. This field is alpha-level and is only populated by servers that enable the EphemeralContainers feature.")
    host_ip: Optional[StrictStr] = Field(None, alias="hostIP", description="IP address of the host to which the pod is assigned. Empty if not yet scheduled.")
    init_container_statuses: Optional[conlist(IoK8sApiCoreV1ContainerStatus)] = Field(None, alias="initContainerStatuses", description="The list has one entry per init container in the manifest. The most recent successful init container will have ready = true, the most recently started container will have startTime set. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-and-container-status")
    message: Optional[StrictStr] = Field(None, description="A human readable message indicating details about why the pod is in this condition.")
    nominated_node_name: Optional[StrictStr] = Field(None, alias="nominatedNodeName", description="nominatedNodeName is set only when this pod preempts other pods on the node, but it cannot be scheduled right away as preemption victims receive their graceful termination periods. This field does not guarantee that the pod will be scheduled on this node. Scheduler may decide to place the pod elsewhere if other nodes become available sooner. Scheduler may also decide to give the resources on this node to a higher priority pod that is created after preemption. As a result, this field may be different than PodSpec.nodeName when the pod is scheduled.")
    phase: Optional[StrictStr] = Field(None, description="The phase of a Pod is a simple, high-level summary of where the Pod is in its lifecycle. The conditions array, the reason and message fields, and the individual container status arrays contain more detail about the pod's status. There are five possible phase values:  Pending: The pod has been accepted by the Kubernetes system, but one or more of the container images has not been created. This includes time before being scheduled as well as time spent downloading images over the network, which could take a while. Running: The pod has been bound to a node, and all of the containers have been created. At least one container is still running, or is in the process of starting or restarting. Succeeded: All containers in the pod have terminated in success, and will not be restarted. Failed: All containers in the pod have terminated, and at least one container has terminated in failure. The container either exited with non-zero status or was terminated by the system. Unknown: For some reason the state of the pod could not be obtained, typically due to an error in communicating with the host of the pod.  More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-phase")
    pod_ip: Optional[StrictStr] = Field(None, alias="podIP", description="IP address allocated to the pod. Routable at least within the cluster. Empty if not yet allocated.")
    pod_ips: Optional[conlist(IoK8sApiCoreV1PodIP)] = Field(None, alias="podIPs", description="podIPs holds the IP addresses allocated to the pod. If this field is specified, the 0th entry must match the podIP field. Pods may be allocated at most 1 value for each of IPv4 and IPv6. This list is empty if no IPs have been allocated yet.")
    qos_class: Optional[StrictStr] = Field(None, alias="qosClass", description="The Quality of Service (QOS) classification assigned to the pod based on resource requirements See PodQOSClass type for available QOS classes More info: https://git.k8s.io/community/contributors/design-proposals/node/resource-qos.md")
    reason: Optional[StrictStr] = Field(None, description="A brief CamelCase message indicating details about why the pod is in this state. e.g. 'Evicted'")
    start_time: Optional[datetime] = Field(None, alias="startTime", description="Time is a wrapper around time.Time which supports correct marshaling to YAML and JSON.  Wrappers are provided for many of the factory methods that the time package offers.")
    __properties = ["conditions", "containerStatuses", "ephemeralContainerStatuses", "hostIP", "initContainerStatuses", "message", "nominatedNodeName", "phase", "podIP", "podIPs", "qosClass", "reason", "startTime"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> IoK8sApiCoreV1PodStatus:
        """Create an instance of IoK8sApiCoreV1PodStatus from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in conditions (list)
        _items = []
        if self.conditions:
            for _item in self.conditions:
                if _item:
                    _items.append(_item.to_dict())
            _dict['conditions'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in container_statuses (list)
        _items = []
        if self.container_statuses:
            for _item in self.container_statuses:
                if _item:
                    _items.append(_item.to_dict())
            _dict['containerStatuses'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in ephemeral_container_statuses (list)
        _items = []
        if self.ephemeral_container_statuses:
            for _item in self.ephemeral_container_statuses:
                if _item:
                    _items.append(_item.to_dict())
            _dict['ephemeralContainerStatuses'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in init_container_statuses (list)
        _items = []
        if self.init_container_statuses:
            for _item in self.init_container_statuses:
                if _item:
                    _items.append(_item.to_dict())
            _dict['initContainerStatuses'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in pod_ips (list)
        _items = []
        if self.pod_ips:
            for _item in self.pod_ips:
                if _item:
                    _items.append(_item.to_dict())
            _dict['podIPs'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> IoK8sApiCoreV1PodStatus:
        """Create an instance of IoK8sApiCoreV1PodStatus from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return IoK8sApiCoreV1PodStatus.parse_obj(obj)

        _obj = IoK8sApiCoreV1PodStatus.parse_obj({
            "conditions": [IoK8sApiCoreV1PodCondition.from_dict(_item) for _item in obj.get("conditions")] if obj.get("conditions") is not None else None,
            "container_statuses": [IoK8sApiCoreV1ContainerStatus.from_dict(_item) for _item in obj.get("containerStatuses")] if obj.get("containerStatuses") is not None else None,
            "ephemeral_container_statuses": [IoK8sApiCoreV1ContainerStatus.from_dict(_item) for _item in obj.get("ephemeralContainerStatuses")] if obj.get("ephemeralContainerStatuses") is not None else None,
            "host_ip": obj.get("hostIP"),
            "init_container_statuses": [IoK8sApiCoreV1ContainerStatus.from_dict(_item) for _item in obj.get("initContainerStatuses")] if obj.get("initContainerStatuses") is not None else None,
            "message": obj.get("message"),
            "nominated_node_name": obj.get("nominatedNodeName"),
            "phase": obj.get("phase"),
            "pod_ip": obj.get("podIP"),
            "pod_ips": [IoK8sApiCoreV1PodIP.from_dict(_item) for _item in obj.get("podIPs")] if obj.get("podIPs") is not None else None,
            "qos_class": obj.get("qosClass"),
            "reason": obj.get("reason"),
            "start_time": obj.get("startTime")
        })
        return _obj


