# coding: utf-8

"""
    Kubernetes

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: unversioned
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr
from benny_kubernetes.models.io_k8s_api_core_v1_secret_reference import IoK8sApiCoreV1SecretReference

class IoK8sApiCoreV1ScaleIOPersistentVolumeSource(BaseModel):
    """
    ScaleIOPersistentVolumeSource represents a persistent ScaleIO volume  # noqa: E501
    """
    fs_type: Optional[StrictStr] = Field(None, alias="fsType", description="Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Default is \"xfs\"")
    gateway: StrictStr = Field(..., description="The host address of the ScaleIO API Gateway.")
    protection_domain: Optional[StrictStr] = Field(None, alias="protectionDomain", description="The name of the ScaleIO Protection Domain for the configured storage.")
    read_only: Optional[StrictBool] = Field(None, alias="readOnly", description="Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.")
    secret_ref: IoK8sApiCoreV1SecretReference = Field(..., alias="secretRef")
    ssl_enabled: Optional[StrictBool] = Field(None, alias="sslEnabled", description="Flag to enable/disable SSL communication with Gateway, default false")
    storage_mode: Optional[StrictStr] = Field(None, alias="storageMode", description="Indicates whether the storage for a volume should be ThickProvisioned or ThinProvisioned. Default is ThinProvisioned.")
    storage_pool: Optional[StrictStr] = Field(None, alias="storagePool", description="The ScaleIO Storage Pool associated with the protection domain.")
    system: StrictStr = Field(..., description="The name of the storage system as configured in ScaleIO.")
    volume_name: Optional[StrictStr] = Field(None, alias="volumeName", description="The name of a volume already created in the ScaleIO system that is associated with this volume source.")
    __properties = ["fsType", "gateway", "protectionDomain", "readOnly", "secretRef", "sslEnabled", "storageMode", "storagePool", "system", "volumeName"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> IoK8sApiCoreV1ScaleIOPersistentVolumeSource:
        """Create an instance of IoK8sApiCoreV1ScaleIOPersistentVolumeSource from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of secret_ref
        if self.secret_ref:
            _dict['secretRef'] = self.secret_ref.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> IoK8sApiCoreV1ScaleIOPersistentVolumeSource:
        """Create an instance of IoK8sApiCoreV1ScaleIOPersistentVolumeSource from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return IoK8sApiCoreV1ScaleIOPersistentVolumeSource.parse_obj(obj)

        _obj = IoK8sApiCoreV1ScaleIOPersistentVolumeSource.parse_obj({
            "fs_type": obj.get("fsType"),
            "gateway": obj.get("gateway"),
            "protection_domain": obj.get("protectionDomain"),
            "read_only": obj.get("readOnly"),
            "secret_ref": IoK8sApiCoreV1SecretReference.from_dict(obj.get("secretRef")) if obj.get("secretRef") is not None else None,
            "ssl_enabled": obj.get("sslEnabled"),
            "storage_mode": obj.get("storageMode"),
            "storage_pool": obj.get("storagePool"),
            "system": obj.get("system"),
            "volume_name": obj.get("volumeName")
        })
        return _obj


