# coding: utf-8

"""
    Kubernetes

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: unversioned
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Dict, List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist
from benny_kubernetes.models.io_k8s_api_core_v1_service_port import IoK8sApiCoreV1ServicePort
from benny_kubernetes.models.io_k8s_api_core_v1_session_affinity_config import IoK8sApiCoreV1SessionAffinityConfig

class IoK8sApiCoreV1ServiceSpec(BaseModel):
    """
    ServiceSpec describes the attributes that a user creates on a service.  # noqa: E501
    """
    cluster_ip: Optional[StrictStr] = Field(None, alias="clusterIP", description="clusterIP is the IP address of the service and is usually assigned randomly by the master. If an address is specified manually and is not in use by others, it will be allocated to the service; otherwise, creation of the service will fail. This field can not be changed through updates. Valid values are \"None\", empty string (\"\"), or a valid IP address. \"None\" can be specified for headless services when proxying is not required. Only applies to types ClusterIP, NodePort, and LoadBalancer. Ignored if type is ExternalName. More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies")
    external_ips: Optional[conlist(StrictStr)] = Field(None, alias="externalIPs", description="externalIPs is a list of IP addresses for which nodes in the cluster will also accept traffic for this service.  These IPs are not managed by Kubernetes.  The user is responsible for ensuring that traffic arrives at a node with this IP.  A common example is external load-balancers that are not part of the Kubernetes system.")
    external_name: Optional[StrictStr] = Field(None, alias="externalName", description="externalName is the external reference that kubedns or equivalent will return as a CNAME record for this service. No proxying will be involved. Must be a valid RFC-1123 hostname (https://tools.ietf.org/html/rfc1123) and requires Type to be ExternalName.")
    external_traffic_policy: Optional[StrictStr] = Field(None, alias="externalTrafficPolicy", description="externalTrafficPolicy denotes if this Service desires to route external traffic to node-local or cluster-wide endpoints. \"Local\" preserves the client source IP and avoids a second hop for LoadBalancer and Nodeport type services, but risks potentially imbalanced traffic spreading. \"Cluster\" obscures the client source IP and may cause a second hop to another node, but should have good overall load-spreading.")
    health_check_node_port: Optional[StrictInt] = Field(None, alias="healthCheckNodePort", description="healthCheckNodePort specifies the healthcheck nodePort for the service. If not specified, HealthCheckNodePort is created by the service api backend with the allocated nodePort. Will use user-specified nodePort value if specified by the client. Only effects when Type is set to LoadBalancer and ExternalTrafficPolicy is set to Local.")
    ip_family: Optional[StrictStr] = Field(None, alias="ipFamily", description="ipFamily specifies whether this Service has a preference for a particular IP family (e.g. IPv4 vs. IPv6).  If a specific IP family is requested, the clusterIP field will be allocated from that family, if it is available in the cluster.  If no IP family is requested, the cluster's primary IP family will be used. Other IP fields (loadBalancerIP, loadBalancerSourceRanges, externalIPs) and controllers which allocate external load-balancers should use the same IP family.  Endpoints for this Service will be of this family.  This field is immutable after creation. Assigning a ServiceIPFamily not available in the cluster (e.g. IPv6 in IPv4 only cluster) is an error condition and will fail during clusterIP assignment.")
    load_balancer_ip: Optional[StrictStr] = Field(None, alias="loadBalancerIP", description="Only applies to Service Type: LoadBalancer LoadBalancer will get created with the IP specified in this field. This feature depends on whether the underlying cloud-provider supports specifying the loadBalancerIP when a load balancer is created. This field will be ignored if the cloud-provider does not support the feature.")
    load_balancer_source_ranges: Optional[conlist(StrictStr)] = Field(None, alias="loadBalancerSourceRanges", description="If specified and supported by the platform, this will restrict traffic through the cloud-provider load-balancer will be restricted to the specified client IPs. This field will be ignored if the cloud-provider does not support the feature.\" More info: https://kubernetes.io/docs/tasks/access-application-cluster/configure-cloud-provider-firewall/")
    ports: Optional[conlist(IoK8sApiCoreV1ServicePort)] = Field(None, description="The list of ports that are exposed by this service. More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies")
    publish_not_ready_addresses: Optional[StrictBool] = Field(None, alias="publishNotReadyAddresses", description="publishNotReadyAddresses, when set to true, indicates that DNS implementations must publish the notReadyAddresses of subsets for the Endpoints associated with the Service. The default value is false. The primary use case for setting this field is to use a StatefulSet's Headless Service to propagate SRV records for its Pods without respect to their readiness for purpose of peer discovery.")
    selector: Optional[Dict[str, StrictStr]] = Field(None, description="Route service traffic to pods with label keys and values matching this selector. If empty or not present, the service is assumed to have an external process managing its endpoints, which Kubernetes will not modify. Only applies to types ClusterIP, NodePort, and LoadBalancer. Ignored if type is ExternalName. More info: https://kubernetes.io/docs/concepts/services-networking/service/")
    session_affinity: Optional[StrictStr] = Field(None, alias="sessionAffinity", description="Supports \"ClientIP\" and \"None\". Used to maintain session affinity. Enable client IP based session affinity. Must be ClientIP or None. Defaults to None. More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies")
    session_affinity_config: Optional[IoK8sApiCoreV1SessionAffinityConfig] = Field(None, alias="sessionAffinityConfig")
    topology_keys: Optional[conlist(StrictStr)] = Field(None, alias="topologyKeys", description="topologyKeys is a preference-order list of topology keys which implementations of services should use to preferentially sort endpoints when accessing this Service, it can not be used at the same time as externalTrafficPolicy=Local. Topology keys must be valid label keys and at most 16 keys may be specified. Endpoints are chosen based on the first topology key with available backends. If this field is specified and all entries have no backends that match the topology of the client, the service has no backends for that client and connections should fail. The special value \"*\" may be used to mean \"any topology\". This catch-all value, if used, only makes sense as the last value in the list. If this is not specified or empty, no topology constraints will be applied.")
    type: Optional[StrictStr] = Field(None, description="type determines how the Service is exposed. Defaults to ClusterIP. Valid options are ExternalName, ClusterIP, NodePort, and LoadBalancer. \"ExternalName\" maps to the specified externalName. \"ClusterIP\" allocates a cluster-internal IP address for load-balancing to endpoints. Endpoints are determined by the selector or if that is not specified, by manual construction of an Endpoints object. If clusterIP is \"None\", no virtual IP is allocated and the endpoints are published as a set of endpoints rather than a stable IP. \"NodePort\" builds on ClusterIP and allocates a port on every node which routes to the clusterIP. \"LoadBalancer\" builds on NodePort and creates an external load-balancer (if supported in the current cloud) which routes to the clusterIP. More info: https://kubernetes.io/docs/concepts/services-networking/service/#publishing-services-service-types")
    __properties = ["clusterIP", "externalIPs", "externalName", "externalTrafficPolicy", "healthCheckNodePort", "ipFamily", "loadBalancerIP", "loadBalancerSourceRanges", "ports", "publishNotReadyAddresses", "selector", "sessionAffinity", "sessionAffinityConfig", "topologyKeys", "type"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> IoK8sApiCoreV1ServiceSpec:
        """Create an instance of IoK8sApiCoreV1ServiceSpec from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in ports (list)
        _items = []
        if self.ports:
            for _item in self.ports:
                if _item:
                    _items.append(_item.to_dict())
            _dict['ports'] = _items
        # override the default output from pydantic by calling `to_dict()` of session_affinity_config
        if self.session_affinity_config:
            _dict['sessionAffinityConfig'] = self.session_affinity_config.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> IoK8sApiCoreV1ServiceSpec:
        """Create an instance of IoK8sApiCoreV1ServiceSpec from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return IoK8sApiCoreV1ServiceSpec.parse_obj(obj)

        _obj = IoK8sApiCoreV1ServiceSpec.parse_obj({
            "cluster_ip": obj.get("clusterIP"),
            "external_ips": obj.get("externalIPs"),
            "external_name": obj.get("externalName"),
            "external_traffic_policy": obj.get("externalTrafficPolicy"),
            "health_check_node_port": obj.get("healthCheckNodePort"),
            "ip_family": obj.get("ipFamily"),
            "load_balancer_ip": obj.get("loadBalancerIP"),
            "load_balancer_source_ranges": obj.get("loadBalancerSourceRanges"),
            "ports": [IoK8sApiCoreV1ServicePort.from_dict(_item) for _item in obj.get("ports")] if obj.get("ports") is not None else None,
            "publish_not_ready_addresses": obj.get("publishNotReadyAddresses"),
            "selector": obj.get("selector"),
            "session_affinity": obj.get("sessionAffinity"),
            "session_affinity_config": IoK8sApiCoreV1SessionAffinityConfig.from_dict(obj.get("sessionAffinityConfig")) if obj.get("sessionAffinityConfig") is not None else None,
            "topology_keys": obj.get("topologyKeys"),
            "type": obj.get("type")
        })
        return _obj


