# coding: utf-8

"""
    Kubernetes

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: unversioned
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from benny_kubernetes.models.io_k8s_api_rbac_v1alpha1_role_ref import IoK8sApiRbacV1alpha1RoleRef
from benny_kubernetes.models.io_k8s_api_rbac_v1alpha1_subject import IoK8sApiRbacV1alpha1Subject
from benny_kubernetes.models.io_k8s_apimachinery_pkg_apis_meta_v1_object_meta import IoK8sApimachineryPkgApisMetaV1ObjectMeta

class IoK8sApiRbacV1alpha1ClusterRoleBinding(BaseModel):
    """
    ClusterRoleBinding references a ClusterRole, but not contain it.  It can reference a ClusterRole in the global namespace, and adds who information via Subject. Deprecated in v1.17 in favor of rbac.authorization.k8s.io/v1 ClusterRoleBinding, and will no longer be served in v1.20.  # noqa: E501
    """
    api_version: Optional[StrictStr] = Field(None, alias="apiVersion", description="APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources")
    kind: Optional[StrictStr] = Field(None, description="Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds")
    metadata: Optional[IoK8sApimachineryPkgApisMetaV1ObjectMeta] = None
    role_ref: IoK8sApiRbacV1alpha1RoleRef = Field(..., alias="roleRef")
    subjects: Optional[conlist(IoK8sApiRbacV1alpha1Subject)] = Field(None, description="Subjects holds references to the objects the role applies to.")
    __properties = ["apiVersion", "kind", "metadata", "roleRef", "subjects"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> IoK8sApiRbacV1alpha1ClusterRoleBinding:
        """Create an instance of IoK8sApiRbacV1alpha1ClusterRoleBinding from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of metadata
        if self.metadata:
            _dict['metadata'] = self.metadata.to_dict()
        # override the default output from pydantic by calling `to_dict()` of role_ref
        if self.role_ref:
            _dict['roleRef'] = self.role_ref.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in subjects (list)
        _items = []
        if self.subjects:
            for _item in self.subjects:
                if _item:
                    _items.append(_item.to_dict())
            _dict['subjects'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> IoK8sApiRbacV1alpha1ClusterRoleBinding:
        """Create an instance of IoK8sApiRbacV1alpha1ClusterRoleBinding from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return IoK8sApiRbacV1alpha1ClusterRoleBinding.parse_obj(obj)

        _obj = IoK8sApiRbacV1alpha1ClusterRoleBinding.parse_obj({
            "api_version": obj.get("apiVersion"),
            "kind": obj.get("kind"),
            "metadata": IoK8sApimachineryPkgApisMetaV1ObjectMeta.from_dict(obj.get("metadata")) if obj.get("metadata") is not None else None,
            "role_ref": IoK8sApiRbacV1alpha1RoleRef.from_dict(obj.get("roleRef")) if obj.get("roleRef") is not None else None,
            "subjects": [IoK8sApiRbacV1alpha1Subject.from_dict(_item) for _item in obj.get("subjects")] if obj.get("subjects") is not None else None
        })
        return _obj


